#include <stdio.h>
#include <stdlib.h>

long long f(long long n) {
    long long rezultat = 0;
    for (long long d = 1; d * d <= n; d++) {
        if (n % d == 0) {
            rezultat ^= d;
            if (d != n / d) {
                rezultat ^= n / d;
            }
        }
    }
    return rezultat;
}

int main() {
    long long broj;
    int brojDelilaca;
    scanf("%lld %d", &broj, &brojDelilaca);

    long long skupDelilaca[100000];
    for (int i = 0; i < brojDelilaca; i++) {
        scanf("%lld", &skupDelilaca[i]);
    }

    for (int i = 0; i < brojDelilaca; i++) {
        long long rezultat = f(skupDelilaca[i]);
        printf("%lld", rezultat);
        if (i < brojDelilaca - 1) printf(" ");
    }
    return 0;
}